<template>

<div id="form" class="form_div"  novalidate="true" >
 <form >
  <div class="columns ">
   <div class="column col-6">
    <div class="form-group">
    <label for="employee_title">Status</label><br/>
    <select v-model="status" id="employee_status" name="employee[status]" type="text" class="new_form_input" v-bind:class="{ active1: statusError}" v-on:keydown= "removeClass_status" v-on:click= "removeClass_status">
      <option  value="Employee">Employee</option>
      <option value="Contractor">Contractor</option>
      <option value="Director">Director</option>
       <option  value="Retired">Retired</option>
      <option value="Resigned">Resigned</option>
      <option value="Discharged">Discharged</option>
    </select>
    <div class="error" v-bind:class="{ display: statusError}"> Cant be blank</div>
   </div> </div>
  <!-- <div class="column col-6">
   <div class="form-group">
    <label for="first_name">First Name</label><br/>
    <input v-model="first_name" id="employee_first_name" name="employee[first_name]" type="text" class="new_form_input" v-bind:class="{ active1: firstnameError}" v-on:keydown= "removeClass_firstname" >
    <div class="error" v-bind:class="{ display: firstnameError}"> Cant be blank</div>
  </div></div>-->
  </div> 

  <div class="columns new_cl">
   <div class="column col-6">
    <div class="form-group">
    <label for="employee_title">Title</label><br/>
    <select v-model="title" id="employee_title" name="employee[title]" type="text" class="new_form_input" v-bind:class="{ active1: titleError}" v-on:keydown= "removeClass_title" v-on:click= "removeClass_title">
      <option  value="Mr">Mr</option>
      <option value="Mrs">Mrs</option>
      <option value="Miss">Miss</option>
    </select>
    <div class="error" v-bind:class="{ display: titleError}"> Cant be blank</div>
   </div> </div>
  <div class="column col-6">
   <div class="form-group">
    <label for="first_name">First Name</label><br/>
    <input v-model="first_name" id="employee_first_name" name="employee[first_name]" type="text" class="new_form_input" v-bind:class="{ active1: firstnameError}" v-on:keydown= "removeClass_firstname" >
    <div class="error" v-bind:class="{ display: firstnameError}"> Cant be blank</div>
  </div></div></div>

  <div class="columns new_cl">
   <div class="column col-6">
    <div class="form-group">
    <label for="employee_surname">Surname</label><br/>
    <input  v-model="surname" id="employee_surname" name="employee[surname]" type="text" class="new_form_input" v-bind:class="{ active1: surnameError}" v-on:keydown= "removeClass_surname" >
    <div class="error" v-bind:class="{ display: surnameError}"> Cant be blank</div>
   </div> </div>
   <div class="column col-6">
    <div class="form-group"> 
     <label for="employee_middle_name">Middle Name</label><br/>
     <input  v-model="middle_name" id="employee_middle_name" name="employee[middle_name]" type="text" class="new_form_input"   v-on:keydown= "removeClass_middlename">
    </div>
  </div>
  </div>


  <div class="columns new_cl">
   <div class="column col-6">
    <div class="form-group">
    <label for="employee_email">Email</label><br/>
    <input  v-model="email" id="employee_email" name="employee[email]" type="text" class="new_form_input" v-bind:class="{ active1: emailError}" v-on:keydown= "removeClass_email" v-on:click= "removeClass_email">
   <div class="error" v-bind:class="{ display: emailError}"> Cant be blank</div>
   <div class="error" v-bind:class="{ display: emailError2}">Incorrect Data Type</div>
  </div> </div>
  <div class="column col-6">
    <div class="form-group"> 
     <label for="employee_phone">Phone</label><br/>
     <input v-model="phone" id="employee_phone" name="employee[phone]" type="text" class="new_form_input" v-bind:class="{ active1: phoneError}" v-on:keydown= "removeClass_phone" >
      <div class="error" v-bind:class="{ display: phoneError}"> Cant be blank</div>
      <div class="error" v-bind:class="{ display: phoneError2}"> Incorrect Data Type</div>
    </div>
  </div>
  </div>
 <div class="columns new_cl">
   <div class="column col-6">
    <div class="form-group">
     <label for="employee_role">Role</label><br/>
     <input v-model="role" id="employee_role" name="employee[role]" type="text" class="new_form_input" v-bind:class="{ active1: roleError}" v-on:keydown= "removeClass_role">
     <div class="error" v-bind:class="{ display: roleError}"> Cant be blank</div>
    </div> </div>
  <div class="column col-6">
   <div class="form-group"> 
    <label for="employee_gender">Gender</label><br/>
    <select v-model="gender " id="employee_gender" name="employee[gender]" type="text" class="new_form_input_gender" v-bind:class="{ active1: genderError}" v-on:keydown= "removeClass_gender" v-on:click= "removeClass_gender">
      <option  value="Male">Male</option>
      <option value="Female">Female</option>
    </select>
    <div class="error" v-bind:class="{ display: genderError}"> Cant be blank</div>
    </div>
   </div>
  </div>

  <div class="columns new_cl">
   <div class="column col-6">
    <div class="form-group">
     <label for="employee_dob">Date of Birth</label><br/>
     <input v-model="dob" id="employee_dob" name="employee[dob]" type="date" class="new_form_input" v-bind:class="{ active1: dobError}" v-on:keydown= "removeClass_dob" v-on:click="removeClass_dob">
     <div class="error" v-bind:class="{ display: dobError}"> Cant be blank</div>
    </div> </div>
  <div class="column col-6">
   <div class="form-group"> 
    <label for="employee_marital_status">Marital Status</label>
    <select v-model="marital_status " id="employee_marital_status" name="employee[marital_status]" type="text" class="new_form_input" v-bind:class="{ active1: maritalError}" v-on:keydown= "removeClass_maritial" v-on:click= "removeClass_maritial">
      <option  value="Single">Single</option>
      <option value="Married">Married</option>
      <option value="Divorced">Divorced</option>
      <option value="Divorced">Seperated</option>
    </select>
    <div class="error" v-bind:class="{ display: maritalError}"> Cant be blank</div>
    </div>
   </div>
  </div>

  <div class="columns new_cl">
   <div class="column col-12">
    <div class="form-group">
      <label for="employee_address">Address</label><br/>
      <input type="text" v-model="address" rows="5" id="employee_address" name="employee[address]"  class="new_form_input_address" v-bind:class="{ active1: addressError}" v-on:keydown= "removeClass_address">
      <div class="error" v-bind:class="{ display: addressError}"> Cant be blank</div>
    </div>
   </div>
  </div>

  <div class="columns t_space">
   <div class="column col-12">
    <div class="form-group">
     <label for="employee_address">Address 2</label><br/> 
      <input type="text" v-model="address_2" rows="5" id="employee_address_2" name="employee[address_2]"  class="new_form_input_address"  >
    </div>
   </div>
  </div>

  <div class="columns new_cl">
   <div class="column col-6">
    <div class="form-group">
    <label for="employee_country">Country</label><br/>
    <!-- <input  v-model="country" id="employee_country" name="employee[country]" type="text" class="new_form_input" v-bind:class="{ active1: countryError}" v-on:keydown= "removeClass_country"> -->
    <select  v-model="country" id="employee_country" name="employee[country]" class="new_form_input" v-bind:class="{ active1: countryError}" v-on:keydown= "removeClass_country" v-on:click= "removeClass_country" v-on:change="chooseState()">
      <option selected>Select Country</option>
      <option v-for="country in countries" v-bind:value="country.id" :key="country.id">{{ country.name }}</option>
    </select>
    <div class="error" v-bind:class="{ display: countryError}"> Cant be blank</div>
  </div> </div>
  <div class="column col-6">
   <div class="form-group"> 
    <label for="employee_state">State</label><br/>
    <!-- <input v-model="state" id="employee_state" name="employee[state]" type="text" class="new_form_input" v-bind:class="{ active1: stateError}" v-on:keydown= "removeClass_state"> -->
    <select v-model="state" id="employee_state" name="employee[state]" type="text" class="new_form_input" v-bind:class="{ active1: stateError}" v-on:keydown= "removeClass_state" v-on:click = "removeClass_state">
      <option>Select State</option>
      <option v-for="state in states" v-bind:value="state.name" :key="state.id">{{ state.name }}</option>
    </select>
    <div class="error" v-bind:class="{ display: stateError}"> Cant be blank</div>
    </div>
   </div>
  </div>

  <div class="columns new_cl">
   <div class="column col-6">
    <div class="form-group">
      <label for="employee_children">Number of Children</label><br/>
      <!-- <input v-model="children" id="employee_children" name="employee[children]" type="number" class="new_form_input" v-bind:class="{ active1: childrenError}" v-on:keydown= "removeClass_children"> -->
      <select v-model="children" id="employee_children" name="employee[children]" type="number" class="new_form_input" v-bind:class="{ active1: childrenError}" v-on:keydown= "removeClass_children" v-on:click= "removeClass_children">
        <option  value="0">0</option>
        <option value="1">1</option>
        <option value="2">2</option>
        <option value="3">3</option>
        <option value="4">4</option>
      </select>
      <div class="error" v-bind:class="{ display: childrenError}"> Cant be blank</div>
    </div> </div>
  <div class="column col-6">
    <div class="form-group"> 
      <label for="employee_dependents">Number of Dependents</label><br/>
      <!-- <input v-model="dependents" id="employee_dependents" name="employee[dependents]" type="number" class="new_form_input" v-bind:class="{ active1: dependentsError}" v-on:keydown= "removeClass_dependents"> -->
      <select v-model="dependents" id="employee_dependents" name="employee[dependents]" type="number" class="new_form_input" v-bind:class="{ active1: dependentsError}" v-on:keydown= "removeClass_dependents" v-on:click= "removeClass_dependents">
        <option value="0">0</option>
        <option value="1">1</option>
        <option value="2">2</option>
      </select>
      <div class="error" v-bind:class="{ display: dependentsError}"> Cant be blank</div>
    </div>
   </div>
  </div>

   <div class="button_div2 columns" >
    <div class="left_btn column col-4"><button v-on:click="closeModal"  class="btn submit_btn3 btn-font" >Cancel</button> </div>
    <div class=" column col-8 columns align">
     <div class=" column col-7 submitAnother ">
      <button v-on:click="submitAnotherEmployee"  class="btn submit_btn3 btn-font">Submit Another</button>
     </div>
     <div class=" column col-4 ">
      <button v-on:click="submitEmployee"  class="btn submit_btn btn-font">Submit</button>
     </div>
    </div>
   </div >
</form> 


</div>
</template>

<script>
import axios from 'axios'
export default {
name:  "Form",
props:['currentEmployee'],
 //props:['counter'],

data: function(){
      return{
        status,
        employee,
        statusError:false,
        titleError:false,
        firstnameError:false,
        surnameError:false,
        middlenameError:false,
        emailError:false,
        emailError2:false,
        phoneError:false,
        phoneError2:false,
        roleError:false,
        genderError:false,
        dobError:false,
        maritalError:false,
        addressError:false,
        countryError:false,
        stateError:false,
        childrenError:false,
        dependentsError:false,
        error:"Can't be blank",
        title: '',
        first_name: '',
        surname: '',
        middle_name: '',
        email: '',
        country: '',
        phone: '',
        address: '',
        address_2: '',
        state: '',
        dob: '',
        role: '',
        gender: '',
        marital_status: '',
        children: '',
        dependents: '',
        csrf: window.csrf_token,
        formerrors: [],
        employee: [],
        isActive:false,
        countries:[],
        states: [],
        selected: ''
      }
    },
    mounted() {
    var self = this
    axios.get('/api/countries').then(function(response){
      // console.log(response.data.data)
      self.countries = response.data.data
        // console.log(self.countries)
    })
      .catch(function (error) {
        console.log(error)
      })
  },
    // define methods under the `methods` object
    methods: {
      chooseState: function(){
        var self =this
        console.log()
        axios.get('/api/states/'+this.country).then(function(response){
          // console.log(response.data.data)
          self.states = response.data.data
            console.log(self.states)
        })
          .catch(function (error) {
            console.log(error)
          })
          
      },
      removeClass_status: function(event){this.statusError=false;},
      removeClass_title: function(event){this.titleError=false;},
      removeClass_firstname: function(event){ this.firstnameError=false;},
      removeClass_surname: function(event){this.surnameError=false;},
      removeClass_middlename: function(event){this.middlenameError=false},
      removeClass_email: function(event){ this.emailError=false; this.emailError2=false;},
      removeClass_phone: function(event){ this.phoneError=false; this.phoneError2=false;},
      removeClass_dob: function(event){this.dobError=false;},
      removeClass_role: function(event){this.roleError=false;},
      removeClass_gender: function(event){this.genderError=false;}, 
      removeClass_maritial: function(event){ this.maritalError=false;},
      removeClass_address: function(event){  this.addressError=false;},
      removeClass_country: function(event){  this.countryError=false;},
      removeClass_state: function(event){  this.stateError=false;},
      removeClass_children: function(event){this.childrenError=false;},
      removeClass_dependents: function(event){this.dependentsError=false;},
      
      showDetails: function (event) {
        this.isActive = true
      },
      close:function (event) {
        this.isActive = false
      },
      closeModal:function (event) {
       this.isActive = false
      },
      validEmail: function (email) {
      var email_check = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
      return email_check.test(email);
    },
      validPhone: function (phone) {
      var phone_check = /^[\s()+-]*([0-9][\s()+-]*){6,20}$/;
      return phone_check.test(phone);
    },
      submitEmployee: function(e){
      e.preventDefault()
      var url = '/employees'
      let csrf = document.querySelector("meta[name='csrf-token']").getAttribute("content");
      const axios = require('axios');
      var form = document.querySelector('form');
      var data = new FormData(form);
      var title = data.get('employee[title]'); 
      var status = data.get('employee[status]'); 
      var first_name = data.get('employee[first_name]'); 
      var surname = data.get('employee[surname]'); 
      var middle_name = data.get('employee[middle_name]'); 
      var email = data.get('employee[email]'); 
      var country = data.get('employee[country]'); 
      var  phone = data.get('employee[phone]'); 
      var address = data.get('employee[address]'); 
      var address_2 = data.get('employee[address_2]'); 
      var state = data.get('employee[state]'); 
      var dob = data.get('employee[dob]'); 
      var role = data.get('employee[role]'); 
      var gender= data.get('employee[gender]'); 
      var marital_status = data.get('employee[marital_status]'); 
      var children = data.get('employee[children]'); 
      var dependents = data.get('employee[dependents]'); 

      /* Form Validation Rules*/
      if(!status ){  this.statusError=true; }  
      if(!title ){  this.titleError=true; }   
      if(first_name == "" ){ this.firstnameError=true} 
      if(surname  == ""){ this.surnameError=true}   
      if(middle_name == ""){  this.middlenameError=true}     
       if(email == ""){ this.emailError=true}  else if (!this.validEmail(this.email)) {this.emailError2="true"}
      if(country == -1 ){ this.countryError=true}    
      if(phone  == ""){  this.phoneError=true}   else if (!this.validPhone(this.phone)) {this.phoneError2="true"} //else if(isNaN(phone )){{this.phoneError2="true"}}   
      if(address == ""){ this.addressError=true}   
      if(!state){ this.stateError=true}    
      if(role== ""){ this.roleError=true}  
      if(!gender){ this.genderError=true}  
      if(!dob){  this.dobError=true}     
      if(!marital_status ){ this.maritalError=true}   
      if(!children){ this.childrenError=true}  
      if(!dependents){ this.dependentsError=true}  
      if(title && status && first_name !== "" && surname !== ""  && email !== "" && this.validEmail(this.email) && country  && phone  !== "" && address !== "" && state  && dob && marital_status  && children  &&  dependents && role !=="" && gender){
      axios.post( url, data, { headers: {'Content-Type': 'text/csv', 'x-csrf-token': csrf}})
      .then((response)=>{
      console.log(response.data.employee.country);
      console.log("Form Submitted");
      this.employee=response.data.employee
      console.log(this.employee)

     this.$emit('submit', this.employee);
     // window.location.reload();

      }).catch(function(error){
        console.log(error);
       });
      }
      },
       validEmail: function (email) {
      var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
      return re.test(email);
    },

      submitAnotherEmployee: function(e){
      e.preventDefault()
      var url = '/employees'
      let csrf = document.querySelector("meta[name='csrf-token']").getAttribute("content");
      const axios = require('axios');
      var form = document.querySelector('form');
      var data = new FormData(form);
      var title = data.get('employee[title]'); 
      var first_name = data.get('employee[first_name]'); 
      var surname = data.get('employee[surname]'); 
      var middle_name = data.get('employee[middle_name]'); 
      var email = data.get('employee[email]'); 
      var country = data.get('employee[country]'); 
      var  phone = data.get('employee[phone]'); 
      var address = data.get('employee[address]'); 
      var address_2 = data.get('employee[address_2]'); 
      var state = data.get('employee[state]'); 
      var dob = data.get('employee[dob]'); 
      var role = data.get('employee[role]'); 
      var gender= data.get('employee[gender]'); 
      var marital_status = data.get('employee[marital_status]'); 
      var children = data.get('employee[children]'); 
      var dependents = data.get('employee[dependents]'); 

      /* Form Validation Rules*/
      if(title  == ""){  this.titleError=true; }   
      if(first_name == "" ){ this.firstnameError=true} 
      if(surname  == ""){ this.surnameError=true}   
      //if(middle_name == " "){  this.middlenameError=true}     
      if(email == ""){ this.emailError=true}  else if (!this.validEmail(this.email)) {this.emailError2="true"}
      if(country == -1 ){ this.countryError=true}    
      if(phone  == ""){  this.phoneError=true}   else if (!this.validPhone(this.phone)) {this.phoneError2="true"} //else if(isNaN(phone )){{this.phoneError2="true"}}   
      if(address == ""){ this.addressError=true}   
      if(state== ""){ this.stateError=true}    
      if(role== ""){ this.roleError=true}  
      if(gender== ""){ this.genderError=true}  
      if(!dob){  this.dobError=true}     
      if(marital_status == ""){ this.maritalError=true}   
      if(children== ""){ this.childrenError=true}  
      if(dependents== ""){ this.dependentsError=true}  
     if(title  && first_name !== "" && surname !== ""  && email !== "" && this.validEmail(this.email) && country !== "" && phone  !== "" && address !== "" && state !== "" && dob && marital_status  && children  &&  dependents && role !=="" && gender){
      axios.post( url, data, { headers: {'Content-Type': 'text/csv', 'x-csrf-token': csrf}})
      .then((response)=>{
      console.log(response.data.employee.country);
      console.log("Form Submitted");
      this.employee=response.data.employee
      console.log(this.employee)
      this.title= '';
      this.first_name= ' ';
      this.surname= ' ',
      this.middle_name= ' ';
      this.email= ' ';
      this.country= ' ';
      this.phone=' ';
      this.address=' ';
      this.address_2=' ';
      this.state= ' ';
      this.dob= ' ';
      this.role= ' ';
      this.gender= ' ';
      this.marital_status= ' ';
      this.children= ' ';
      this.dependents= ' ';
      this.titleError=false;
      this.firstnameError=false;
      this.surnameError=false;
      this.middlenameError=false;
      this.emailError=false;
      this.emailError2=false;
      this.countryError=false;
      this.phoneError=false;
      this.addressError=false;
      this.stateError=false;
      this.roleError=false;
      this.genderError=false;
      this.dobError=false;
      this.maritalError=false;
      this.childrenError=false;
      this.dependentsError=false;
      //window.location.reload();
      }).catch(function(error){
      console.log(error);
      });
      }}
    }
  }
  
 
</script>
<style >

</style>